VERSION 5.00
Begin VB.Form Form1 
   Caption         =   "Form1"
   ClientHeight    =   4710
   ClientLeft      =   60
   ClientTop       =   345
   ClientWidth     =   4875
   LinkTopic       =   "Form1"
   ScaleHeight     =   4710
   ScaleWidth      =   4875
   StartUpPosition =   3  'Windows Default
End
Attribute VB_Name = "Form1"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit

' Draw a pie chart on object obj with the indicated values.
Private Sub DrawPieChart(ByVal obj As Object, values() As Single, ByVal cx As Single, ByVal cy As Single, ByVal radius As Single)
Const PI As Single = 3.14159265
Dim angles() As Single
Dim i As Integer
Dim total As Single
Dim clr As Integer

    ' Convert the values into angles in radians.
    ReDim angles(LBound(values) - 1 To UBound(values))
    total = 0
    For i = LBound(values) To UBound(values)
        total = total + values(i)
    Next i
    For i = LBound(values) To UBound(values)
        angles(i) = 2 * PI * values(i) / total
    Next i

    ' Add a first value that is a tiny positive value.
    angles(LBound(values) - 1) = 0.0000001

    ' Make each angle be the sum of those before it.
    For i = LBound(values) To UBound(values)
        angles(i) = angles(i) + angles(i - 1)
        If angles(i) > 2 * PI Then angles(i) = 2 * PI
    Next i

    ' Draw the pie chart.
    clr = 1
    obj.FillStyle = vbFSSolid
    For i = LBound(angles) To UBound(angles) - 1
        obj.FillColor = QBColor(clr)
        obj.Circle (cx, cy), radius, vbBlack, -angles(i), -angles(i + 1)
        clr = clr + 1
        If clr > 15 Then clr = 1
    Next i
End Sub
Private Sub Form_Load()
Dim values(0 To 9) As Single
Dim i As Integer

    ' Make some random data.
    Randomize
    For i = LBound(values) To UBound(values)
        values(i) = 20 + Rnd * 100
    Next i

    ' Draw the pie chart.
    Me.AutoRedraw = True
    DrawPieChart Me, values, Me.ScaleWidth / 2, Me.ScaleHeight / 2, 2000
End Sub


